;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; CZYTNIK KART RFID
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;; Copyright (C) 2002 Pawe Moll <hornet@sltzn.katowice.pl>

;; Niniejszy program jest wolnym oprogramowaniem; moesz go 
;; rozprowadza dalej i/lub modyfikowa na warunkach Powszechnej
;; Licencji Publicznej GNU, wydanej przez Fundacj Wolnego
;; Oprogramowania - wedug wersji 2-giej tej Licencji lub ktrej
;; z pniejszych wersji. 

;; Niniejszy program rozpowszechniany jest z nadziej, i bdzie on 
;; uyteczny - jednak BEZ JAKIEJKOLWIEK GWARANCJI, nawet domylnej 
;; gwarancji PRZYDATNOCI HANDLOWEJ albo PRZYDATNOCI DO OKRELONYCH 
;; ZASTOSOWA. W celu uzyskania bliszych informacji - Powszechna 
;; Licencja Publiczna GNU. 

;; Z pewnoci wraz z niniejszym programem otrzymae te egzemplarz 
;; Powszechnej Licencji Publicznej GNU (GNU General Public License);
;; jeli nie - napisz do Free Software Foundation, Inc., 675 Mass Ave,
;; Cambridge, MA 02139, USA.



	mov SP, #STACK_START ; inicjacja stosu
	jmp START	; skok do programu gwnego

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; STAE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;; BITY

LED_GREEN	bit P1.2 ; bity sterujce "urzdzeniami wyjciowymi"
LED_RED		bit P1.3
RELAY		bit P1.4

ASIC_SCLK	bit P3.7 ; bity interfejsu ASICa
ASIC_DATA	bit P1.0
ASIC_RESET	bit IE0	; ten jest na wejciu przerwania zewnetrznego, wic
			; badamy flag...

A0		bit P1.5 ; bity adresu urzdzenia
A1		bit P1.7

CMD_GET		bit 00h	; flaga oznaczajca potrzebe pobrania komendy
CODE_VALID	bit 01h	; flaga wskazujca obecno poprawnego kodu karty w buforze

DE		bit P3.5 ; DE drajwera RS485

;; KOMRKI PAMICI

STACK_START	equ 3fh ; pocztek stosu

ADR		equ 05h	; adres urzdzenia
CMD		equ 07h	; kod odebranej komendy

CODE_BUF	equ 10h	; bufor na odebrany kod karty
TEMP_BUF	equ 18h	; bufor pomocniczy


;; STAE LICZBOWE

ADR_OFFSET	equ 5	; ofset adresu urzdzenia
OPEN_TIME	equ 3	; dugo otwarcia drzwi (w sekundach)

CONTROLLER_ADR	equ 0	; adres kontrolera systemu

CMD_NONE	equ 0	; komendy
CMD_OPEN	equ 'O'
CMD_SENDCODE	equ 'C'

CODE_LEN	equ 5	; ilo bajtw kodu karty



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; PODPROGRAMY OBSUGI PRZERWA
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;; SINT
;; obsuga interfejsu szeregowego

	org SINT

	jnb RI, sint_ret ; obsluga tylko dla znaku przychodzacego

	push ACC
	push 1
	mov A, SBUF	; pobranie znaku
	clr RI

	jb CMD_GET, sint_cmd ; czy to ma byc komenda?
	mov R1, A
	mov A, ADR
	add A, #'0'
	cjne A, 1, sint_end ; czy odebrany znak jest naszym adresem?
	setb CMD_GET
	jmp sint_end
sint_cmd:		
	mov CMD, A	; to rzekomo komenda - zapamitajmy j
	clr CMD_GET
sint_end:
	pop 1
	pop ACC
sint_ret:
	reti



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; PROGRAM GOWNY
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	org 100h

START:	
	call INIT	; inicjacja ukadu

ready:	call ASIC_TEST	; test czytnika
	clr C
	subb A, #1	; oczekiwanie na gotowo
	jz ready

	call ASIC_TEST	; gotowy, test raz jeszcze
	call ERROR	; obsuga ew. bdu

;; GOWNA PTLA PROGRAMU

main:
	call ASIC_READ	; czytaj kart

	mov A, CMD	; czy przysza jaka komenda?
	cjne A, #CMD_NONE, command 
	jmp main



;; OBSUGA KOMEND

command:
	mov CMD, #CMD_NONE
	
	cjne A, #CMD_OPEN, c_1 ; komenda otwarcia drzwi
	jmp open
c_1:	cjne A, #CMD_SENDCODE, c_2 ; komenda wysania kodu karty
	jmp sendcode
c_2:
	mov A, #'?'	; nieznana komenda
	call ANSWER
	jmp main



open:			; otwarcie drzwi
	setb LED_RED
	clr LED_GREEN
	setb RELAY
	mov A, #'+'	; potwierdzenie wykonania
	call ANSWER

	mov R0, #OPEN_TIME ; zwoka
o_loop:	call PAUSE_1S
	djnz R0, o_loop

	clr RELAY
	setb LED_GREEN
	clr LED_RED
	jmp main



sendcode:		; wysanie kodu ostatnio odczytanej karty
	jnb CODE_VALID, sc_none

	mov A, #'+'	; kod poprawny
	call ANSWER

	mov R0, #CODE_BUF ; wysanie bufora
	mov R1, #CODE_LEN
sc_send:
	mov A, @R0
	call HEXSEND
	inc R0
	djnz R1, sc_send
	clr CODE_VALID

	jmp main

sc_none:
	mov A, #'-'	; brak kodu w buforze
	call ANSWER
	jmp main


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; PODPROGRAMY
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;; INIT
;; ogolna inicjacja ukadu
;; WE: brak
;; WY: brak
;; !!! zmienia zawarto A i R0 oraz C

INIT:
	clr RELAY	; wyczenie przekanika

	clr LED_RED	; ustawienie did (czerwona si wieci)
	setb LED_GREEN

	clr A		; pobranie i zapamitanie adresu urzdzenia
	mov C, A1
	cpl C
	rlc A
	mov C, A0
	cpl C
	rlc A
	add A, #ADR_OFFSET
	mov ADR, A

	mov CMD, #CMD_NONE ; brak komendy
	clr CMD_GET

	clr CODE_VALID	; brak kodu w buforze
	
	call RS_INIT	; inicjacja interfejsu szeregowego

	mov A, TMOD	; zegar T0 w trybie 1
	anl A, #11110000b
	orl A, #00000001b
	mov TMOD, A	
	setb TR0	; niech sobie leci...

	setb IT0	; zaczmy sprawdzanie RESETu watchdog'a 

	setb EA		; zaczenie obsugi przerwa

	ret



;; ERROR
;; jeli A != 0 wysya komunikat o bdzie prbujc zapobiec kolizji,
;; zaczyna pulsowa czerwon diod, zawiesza wykonywanie programu
;; WE: A - kod bdu
;; WY: brak
;; !!! moe zmieni zawarto R0 (co i tak nie ma znaczenia)

ERROR:
	cjne A, #0, er_send ; czy mamy bd?
	ret
er_send:
	clr EA		; wycza obsug przerwa
	push ACC

er_wait:		; czeka na cisz na linii przez 2 ms
	mov R0, #250
er_try:	jnb RXD, er_wait	
	djnz R0, er_try

	mov A, #'!'	; znacznik bdu
	call ANSWER
	pop ACC		; kod bdu
	add A, #'0'	
	call RS_SEND

er_loop:
	cpl LED_RED
	call PAUSE_1S
	jmp er_loop



;; ANSWER
;; wysya nagwek informacji (adres rdowy, docelowy, znacznik)
;; WE: A - znacznik do wysania 
;; WY: brak

ANSWER:
	push ACC

	mov A, #CONTROLLER_ADR ; adres docelowy (kontroler)
	add A, #'0'
	call RS_SEND
	mov A, ADR	; adres rdowy (my)
	add A, #'0'
	call RS_SEND

	pop ACC		; znacznik
	call RS_SEND

	ret



;; PAUSE_1S 
;; programowa przerwa o dugoci 1 sek. 
;; WE: brak
;; WY: brak

PAUSE_1S:
	push 0
	push 1

	mov R0, #250	; wartosci skalkulowane dla kwarca 6MHz
p1s_l1: mov R1, #250
p1s_l2: nop		
	nop
	nop
	nop
	nop
	nop
        djnz R1, p1s_l2	; ((6 * nop + 1 * djnx)=8 taktow) * 250 = 2000 taktow
	djnz R0, p1s_l1	; (2000 taktow * 250 = 500000 taktow) * (2 us na takt) = 1 s

	pop 1
	pop 0
	ret



;; HEXSEND
;; wysya na interfejs szeregowy kod znaku zapisany szesnastokowo w ASCII
;; WE: A - znak do wysania
;; WY: brak

HEXSEND:
	push ACC
	push ACC

	anl A, #11110000b ; wyznaczamy kod wyszych czterech bitw
	swap A
	cjne A, #10, hs_0 ; A < 10?
hs_0:	jc hs_1
	add A, #7
hs_1:	add A, #'0'
	call RS_SEND
	
	pop ACC
	anl A, #00001111b ; i modszych...
	cjne A, #10, hs_2 ; A < 10?
hs_2:	jc hs_3
	add A, #7
hs_3:	add A, #'0'
	call RS_SEND

	pop ACC
	ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; PODPROGRAMY OBSUGI INTERFEJSU SZEREGOWEGO
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;; RS_INIT
;; inicjuje interfejs szeregowy - tryb 1, prdko transmisji 1200bps
;; WE: brak
;; WY: brak

RS_INIT:
	push ACC

	clr SM0		; tryb 1
	setb SM1
	setb REN	; zacz odbiornik
	setb ES		; zgaszanie przerwania z interfejsu

	mov TH1, #0f3h	; warto zegara taktujcego dla 1200bps i 6MHz
	mov TL1, #0f3h	
	mov A, TMOD
	anl A, #00001111b
	orl A, #00100000b
	mov TMOD, A	; zegar T1 w trybie 2
	setb TR1

	clr DE		; (RS485) stan wysokiej impedancji nadajnika 

	pop ACC
	ret



;; RS_SEND
;; wysya znak z akumulatora przez interfejs szeregowy
;; WE: A - kod znaku do wysania
;; WY: brak

RS_SEND:
	setb DE		; (RS485) zajmujemy lini
	mov SBUF, A
rss_w:	jnb TI, rss_w	; oczekiwanie na zakoczenie wysyania
	clr TI
	clr DE		; (RS485) zwalniamy lini

	ret

	

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; PODPROGRAMY OBSUGI CZYTNIKA KART (ASIC'A)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;; ASIC_TEST
;; sprawdza poczenie z ASICiem i jego status
;; WE: brak
;; WY: A=0 - ok
;;       1 - czytnik niegotowy
;;       2 - bd interfejsu
;;       3 - problem z anten

ASIC_TEST:
	mov A, #11010000b ; TEST INTERFACE (X1 = 0, X2 = 1)
	call ASIC_SEND4
	call ASIC_GET4
	cjne A, #0010b, at_er2	; zwrci zanegowane X1 i X2?

	mov A, #01000000b ; READ STATUS
	call ASIC_SEND4
	call ASIC_GET4
	push ACC
	anl A, #1000b	; ANTFAIL?
	jnz at_er3
	pop ACC
	anl A, #0001	; READY?
	jz at_er1

	clr A		; wszystko w porzdku
	ret

at_er1:	mov A, #1	; bd 1
	ret

at_er2:	mov A, #2	; bd 2
	ret

at_er3:	pop ACC		; bd 3
	mov A, #3	
	ret


;; ASIC_SEND4
;; wysya 4-bitowy rozkaz do ASICa
;; WE: A - (starsze 4 bity) rozkaz do wysania
;; WY: brak

ASIC_SEND4:
	push PSW
	push ACC
	push 0

	clr ASIC_DATA	; reset
	clr ASIC_SCLK
	setb ASIC_SCLK	
	nop
	setb ASIC_DATA
	nop
	clr ASIC_SCLK

	mov R0, #4
as4_loop:
	rlc A		; kolejny bit na DATA
	mov ASIC_DATA, C
	nop
	setb ASIC_SCLK	; zbocze na SCLK
	nop
	clr ASIC_SCLK
	djnz R0, as4_loop

	setb ASIC_DATA	; powrt do stanu wysokiej impedancji
	pop 0
	pop ACC
	pop PSW
	ret



;; ASIC_SEND8
;; wysya 8-bitowy rozkaz do ASICa
;; WE: A - rozkaz do wysania
;; WY: brak

ASIC_SEND8:
	push PSW
	push ACC
	push 0

	clr ASIC_DATA	; reset
	clr ASIC_SCLK
	setb ASIC_SCLK	
	nop
	setb ASIC_DATA
	nop
	clr ASIC_SCLK

	mov R0, #8
as8_loop:
	rlc A		; kolejny bit na DATA
	mov ASIC_DATA, C
	nop
	setb ASIC_SCLK	; zbocze na SCLK
	nop
	clr ASIC_SCLK
	djnz R0, as8_loop

	setb ASIC_DATA	; powrt do stanu wysokiej impedancji
	pop 0
	pop ACC
	pop PSW
	ret



;; ASIC_GET4
;; pobiera 4-bitow odpowied ASICa
;; WE: brak
;; WY: A - (modsze 4 bity) informacja z ASICa

ASIC_GET4:
	push PSW
	push 0

	setb ASIC_DATA	; do odczytu
	clr A

	mov R0, #4
ag_loop:
	setb ASIC_SCLK	; zbocze narastajce
	mov C, ASIC_DATA ; odczytujemy 
	clr ASIC_SCLK	; nastpny bit...
	rlc A		; zapamita to co byo
	djnz R0, ag_loop

	pop 0
	pop PSW
	ret
	


;; ASIC_READ
;; odczytuje zawarto karty, jeli ta jest w zasigu
;; w przypadku powodzenia wpisuje kod do bufora i ustawia flag CODE_VALID
;; WE: brak
;; WY: brak

ASIC_READ:
	push PSW
	push ACC
	push 0
	push 1
	push 2

	mov A, #10010000b ; WATCHDOG
	call ASIC_SEND4
	clr ASIC_DATA
	setb ASIC_DATA	; impuls startujcy
	nop
	clr ASIC_DATA
	clr ASIC_RESET	; flaga zgoszenia RESETu

	mov A, #10000000b ; DATA OUT
	call ASIC_SEND4
	setb ASIC_DATA	; stan wysokiej impedancji

	; od tej chwili rozmawiamy bezporednio z kart! (tryb REAL-TIME)
	
ar_detect:		; poszukiwanie pierwszego zbocza
	clr A		; czycimy bufor
	clr C

	jb ASIC_DATA, ar_det0
ar_det1: 
	jb ASIC_RESET, ar_retl ; sprawdzamy ew. koniec trybu REAL-TIME
	jnb ASIC_DATA, ar_det1 ; narastajcego
	setb C		; 1 do bufora
	jmp ar_wait
ar_det0:
	jb ASIC_RESET, ar_retl	; sprawdzamy ew. koniec trybu REAL-TIME
	jb ASIC_DATA, ar_det0 ; opadajcego
	clr C		; 0 do bufora


ar_wait:		; czekamy ok. 338 uS (do nastpnego bitu)
	clr TF0
	mov TH0, #255
	mov TL0, #86	
ar_w450:		; a w midzyczasie
	mov AC, C	; zapamitujemy C (zaraz je zmienimy przez cjne)
	jnc ar_wck	; sprawdzamy czy w buforze s same jedynki
	cjne A, #11111111b, ar_wck 
	jmp ar_found	; znaczy si zaczlimy szczliwie czyta kart!
ar_wck:	
	mov C, AC	; przywracamy C
ar_wloop:		; petla 338 uS
	jb ASIC_RESET, ar_retl	; sprawdzamy ew. koniec trybu REAL-TIME
	jnb TF0, ar_wloop 


ar_search:		; przez (troche ponad) 174 uS...
	clr TF0
	mov TH0, #255
	mov TL0, #168
	
	jb ASIC_DATA, ar_sea0 ; ...szukamy kolejnego zbocza...
ar_sea1:
	jb TF0, ar_detect ; jeli T0 przepeniony zaczynamy od pocztku
	jnb ASIC_DATA, ar_sea1 ; ...narastajcego
	rlc A		; 1 do bufora
	setb C
	jmp ar_wait
ar_sea0:
	jb TF0, ar_detect ; jeli T0 przepeniony zaczynamy od pocztku
	jb ASIC_DATA, ar_sea0 ; ...opadajcego
	rlc A		; 0 do bufora
	clr C
	jmp ar_wait


ar_retl:
	jmp ar_ret	; jb ju nie wystarcza (potrzebny skok daleki)


ar_found:		; czytamy zawarto karty (z kontrol poprawnoci)
	clr LED_GREEN	; mrugnijmy diod
	mov R0, #TEMP_BUF ; pocztek bufora
	mov R1, #CODE_LEN ; bajtw do odczytania
	mov R2, #0	; ile odczytanych bitw w A
	clr A

ar_next:
	jb ASIC_RESET, ar_retl ; sprawdzamy ew. koniec trybu REAL-TIME
	jnb TF0, ar_next ; dokoczmy te 338 uS przerwy
	jb ASIC_DATA, ar_get0 ; teraz szukamy zbocza (p.n.p. bdzie)
ar_get1:
	jb ASIC_RESET, ar_retl ; (koniec trybu REAL-TIME?)
	jnb ASIC_DATA, ar_get1 ; narastajcego
	setb AC
	jmp ar_save
ar_get0:
	jb ASIC_RESET, ar_retl ; (koniec trybu REAL-TIME?)
	jb ASIC_DATA, ar_get0 ; opadajcego
	clr AC
ar_save:
	clr TF0		; i znowu 338 uS przerwy...
	mov TH0, #255
	mov TL0, #86
	inc R2		; odczytalimy kolejny bit
	cjne R2, #5, ar_t10 ; nie jest to przypadkiem perwszy bit parzystoci?
	jmp ar_pr
ar_t10:	cjne R2, #10, ar_nopr ; a moe drugi?
ar_pr:
	push ACC	; obliczenie parzystoci wiersza (ostatnich 4 bitw)
	anl A, #00001111b 
	mov C, P	; C = 0 -> jest parzysta liczba 1
	pop ACC
	jc ar_pr1
	jb AC, ar_prerr ; BLAD! C = 0 i AC = 1
	jmp ar_prok
ar_pr1:	jnb AC, ar_prerr ; BLAD! C = 1 i AC = 0
ar_prok:		; bez bdu
	cjne R2, #10, ar_next
	mov R2, #0
	mov @R0, A	; skompletowany bajt do bufora
	inc R0
	djnz R1, ar_next ; jeszcze co do czytania?
	jmp ar_finish
ar_nopr:
	mov C, AC
	rlc A		; odczytany bit do bufora
	jmp ar_next


ar_prerr:		; obsuga bdu (przerywamy czytanie)
	jmp ar_detect


ar_finish:		; sczytalimy wszystkie wiersze danych
	mov R2, #4	; jeszcze cztery bity parzystoci w kolumnach
	clr A
ar_pc:
	jb ASIC_RESET, ar_ret ; sprawdzamy ew. koniec trybu REAL-TIME
	jnb TF0, ar_pc ; dokoczmy te 338 uS przerwy
	jb ASIC_DATA, ar_pc0 ; i szukamy zbocza...
ar_pc1:
	jb ASIC_RESET, ar_ret ; (koniec trybu REAL-TIME?)
	jnb ASIC_DATA, ar_pc1 ; ...narastajcego
	setb C
	rlc A
	jmp ar_pcs
ar_pc0:
	jb ASIC_RESET, ar_ret ; (koniec trybu REAL-TIME?)
	jb ASIC_DATA, ar_pc0 ; ...opadajcego
	clr C
	rlc A
ar_pcs:	
	clr TF0		; i znowu 338 uS przerwy...
	mov TH0, #255
	mov TL0, #86
	djnz R2, ar_pc

	mov R0, A	; zapamitujemy informacj...
	
	
	mov R1, #TEMP_BUF ; obliczenie parzystoci kolumn
	mov R2, #CODE_LEN
	clr A
ar_sum:
	xrl A, @R1	; w wyniku parzystoci poszczeglnych bitw
	inc R1		; wszystkich danych (A.x = 1 - nieparzysta ilosc)
	djnz R2, ar_sum

	mov R1, A	; i jeszcze posumowa mod 2 powki bajtu
	anl 1, #00001111b
	swap A
	anl A, #00001111b
	xrl A, R1
	
	xrl A, R0	; porwnujemy sum z informacj otrzyman
	jnz ar_detectl	; nie ma zera? BAD!


	mov R0, #TEMP_BUF ; przepisanie bufora tymcz. do bufora kodu
	mov R1, #CODE_BUF
	mov R2, #CODE_LEN
ar_send:
	mov A, @R0
	mov @R1, A
	inc R0
	inc R1
	djnz R2, ar_send

	setb CODE_VALID	; mamy kod w buforze...

ar_ret:
	setb ASIC_SCLK	; koniec trybu REAL-TIME, wracamy do domu
	nop
	clr ASIC_SCLK

	setb LED_GREEN

	pop 2
	pop 1
	pop 0
	pop ACC
	pop PSW
	ret
	
ar_detectl:
	jmp ar_detect	; daleki skok...

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; KONIEC
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	end
